;Programa, kurios pirmasis parametras - skaičius, visi kiti - failų vardai.
;Visus failus suskaidome į gabalus, kuriuos sudedame į failus, 
;o jų pavadinimų priekyje įrašome bloko pavadinimą. 
;Pvz.: jei eilutė yra split 200 failas.dat, tuomet failą failas.dat 
;skaldomas po 200 simbolių ir sukuriami failai 1failas.dat, 2failas.dat, ir t.t

.model small
.stack 100h

.data
	pranesimas1 db "Iveskite parametrus: skaiciu ir failu pavadinimus, /? - pagalba", 0Ah, 0Dh, 24h	;Išvedama, jei nepateikiami parametrai kviečiant 
	pranesimas2 db "Neivesti reikiami parametrai" , 0Ah, 0Dh, 24h
	klaida1 db "Nepavyko atidaryti failo nuskaitymui", 0Ah, 0Dh, 24h
	klaida2 db "Nepavyko atidaryti failo, i kuri bus rasoma", 0Ah, 0Dh, 24h
	klaida3 db "Nepavyko nuskaityti nuskaityti duomenu is failo",0Ah, 0Dh, 24h
	klaida4 db "Nepavyko irasyti duomenu i faila",0Ah, 0Dh, 24h
	klaida5 db "Nepavyko uzdaryti nuskaitomo failo", 0Ah, 0Dh, 24h
	klaida6 db "Nepavyko uzdaryti irasinejamo failo", 0Ah, 0Dh, 24h
	pagalbos_pranesimas db "***Pagalbos pranesimas***", 0Ah, 0Dh, 24h								
	stdin db 255																					;Per STDIN įvedamų parametrų bufferio dydis
	paramdydis db ?															 						;Kiek simbolių yra parametrų eilutėj
	parameil db 255 dup (24h)																		;Saugojama parametrų eilutė
	skaicius dw ?																					;Saugojamas įvestas skaičius
	daliklis dw 10																					;Naudojamas konvertuojant įvestą skaičių
	in_failas db 50 dup (0)																			;Input failo pavadinimas
	out_failas db 50 dup (0)																		;Output failo pavadinimas
	buff db 250 dup (?)																				;Saugojamas failų tekstas
	gabalai dw ?																					;Kaskart nuskaitomų simbolių kiekis
	gabalai_n db ?																					;Kiek bus nuskaitoma tokių gabalų vienai failo 'skaidulai'
	pask_gabalas db ?																				;Kiek simbolių nuskaitys paskutiniam gabale
	in_fh dw ?																						;Įvesties failo handle
	out_fh dw ?																						;Išvesties failo handle

.code
;---------------------------------
;Išvesties failo pavadinimas
;---------------------------------
	formuoja_pavadinima:
		cmp [out_failas+2], 90			;Tikrina, ar prievardžio gale Z
		je xxx			
		inc [out_failas+2]				;Jei ne, imama sekanti abc raidė
		ret
			xxx:
			mov [out_failas+2], 65		;Jei gale Z, ją verčia A
			cmp [out_failas+1], 90		;Tikrina, ar vidury Z
			je xx
			inc [out_failas+1]			
			ret
				xx:
				mov [out_failas+1], 65	;Jei vidury Z, ją verčia A
				inc [out_failas]		
	ret
;---------------------------------		
	pradzia:
		mov dx, @data
		mov ds, dx	
;*********************************
;Parametrų eilutės skaitymas
;*********************************	
		xor cx, cx
		mov cl, es:[80h]			;Parametrų eilutės dydis
		cmp cl, 0h
		je stdin_ivedimas			;Neradus parametrų, jie įvedami per stdin		
		
		xor bx, bx
		dec cx						;Neskaičiuojamas pirmas tarpas
		mov paramdydis, cl			;Išsaugojamas eilutės dydis
		mov si, 0000h
		
	skaito_eilute:					
		mov bl, es:[82h+si]			
		mov [parameil + si], bl
		inc si
		loop skaito_eilute
		
		jmp po_nuskaitymo
		
	stdin_ivedimas:
		mov ah, 09h					
		mov dx, offset pranesimas1	;Spausdinamas pradžios pranešimas
		int 21h				
		
		mov ah, 0Ah					
		mov dx, offset stdin		;Nuskaitoma eilutė
		int 21h		
		
		mov cl, paramdydis			;Nieko neįvedus, baigiama programa
		cmp cl, 0h
		je spausdina_pranesima2	
;*********************************
;Pagalbos pranešimas
;*********************************		
	po_nuskaitymo:
		mov cl, paramdydis
		mov si, 0000h
		
	iesko_slasho:
		inc si
		cmp [parameil+si-1], '/'
		je iesko_klaustuko
		loop iesko_slasho
		
		jmp po_pagalbos
		
	iesko_klaustuko:
		cmp [parameil+si], '?'
		je pagalba
		loop iesko_slasho
		
	pagalba:
		mov ah, 09h					
		mov dx, offset pagalbos_pranesimas	
		int 21h	
		jmp pabaiga					;Iškvietus pagalbą, programa baigiama											
;*********************************
;Įvesto skaičiaus saugojimas
;*********************************	
	po_pagalbos:
		xor cx, cx
		xor si, si
		xor ax, ax
		mov cl, paramdydis
		
	saugo_skaiciu:
		cmp cx, 0
		je spausdina_pranesima2		;Neįvedus parametrų, baigiama programa
		cmp [parameil + si], 20h
		je po_saugojimo				;Jei tarpas, nustojama skaityt skaitmenis
		cmp [parameil + si], 30h	
		jb spausdina_pranesima2		;Jei pirmas parametras ne skaičius, klaidos pranešimas
		cmp [parameil + si], 39h
		ja spausdina_pranesima2
		xor bx, bx
		mov bl, [parameil + si]
		sub bx, 30h					;ASCII konvertuojama į skaitmenį
		mul daliklis				;Dauginama iš 10, kad pastumti poziciją
		add ax, bx					;Pridedami vienetai
		inc si	
		dec cx
		jmp saugo_skaiciu
		jmp po_saugojimo
		
	spausdina_pranesima2:
		xor al, al
		mov ah, 09h					;Eilutės spausdinimo funkcija
		mov dx, offset pranesimas2	;Spausdinamas pradžios pranešimas
		int 21h	
		jmp pabaiga		
;*********************************
;Kaip reikės dirbti su bufferiu
;*********************************
	po_saugojimo:
		mov skaicius, ax
		cmp ax, 250					;Lygina, ar įvestas skaičius didesnis už bufferį
		ja iesko_gabalu				;Jei taip, nuskaitymas vyks suskaidytai
		mov gabalai, ax				;Jei ne, bus nuskaitoma iškart nurodytas kiekis simbolių
		mov pask_gabalas, al
		mov gabalai_n, 1			;Bufferis kiekvienai 'skaidulai' užpildomas per vieną kartą

		jmp pasiruosia_nuskaitymui

	iesko_gabalu:
		mov bx, 00FAh				;Dalybai paruošiamas bufferio dydis (250)
		mov gabalai, bx				;Bus nuskaitoma po 250 simbolių
		div bl						;Ieškoma, kiek kartų reiks panaudot bufferį vienai 'skaidulai' sukurti
		cmp ah, 0					
		ja prideda_viena_gabala
		mov gabalai_n, al			;Kiek kartų reiks užpildyti bufferį vienai 'skaidulai'
		mov pask_gabalas, 250
		jmp pasiruosia_nuskaitymui
	
	prideda_viena_gabala:			;Esant liekanai, papildomai prisideda dar vienas kartas
		inc al
		mov gabalai_n, al
		mov pask_gabalas, ah
;*********************************
;Failo pavadinimo nuskaitymas
;*********************************
	pasiruosia_nuskaitymui:	
		dec cx						;Praleidžiamas tarpas po skaičiaus
		inc si

	pasiruosia_nuskaitymui2:		;Tvarkomos reikšmės tęsiant kitų failų nuskaitymą
		xor di, di					;Output pavadinimo rodyklė
		xor dx, dx					
		
	skaito_failo_pav:	
		cmp cx, 0					;Tikrina, ar liko ką skaityti tarp parametrų
		je perskaite	
		cmp [parameil+si], 20h		;Ar nesibaigė pavadinimas
		je perskaite
		mov dl, [parameil+si]
		mov [in_failas+di], dl		;Saugojamas input failo pavadinimas
		mov [out_failas+4+di],dl	;Output failo pirmos 4 pozicijos laisvos
		inc si
		inc di
		dec cx
		jmp skaito_failo_pav
		
	perskaite:				
		mov [in_failas+di],0		;Failų pavadinimai pabaigiami nuliais
		mov [out_failas+4+di], 0	
		mov [out_failas], 65		;Output failo priekis užpildomas A raidėm
		mov [out_failas+1], 65
		mov [out_failas+2], 65
		mov [out_failas+3], 95		;Prievardis atskiriamas brūkšniu
		inc si
		cmp cx, 0
		jne mazina					;Jei nebeliko simbolių, cx nemažinamas
		jmp atidaro_in_faila	
		
	mazina:
		dec cx						;Kad neskaityti tarpo grįžus prie failų pavadinimų nuskaitymo
		jmp atidaro_in_faila
		
	@klaida_atidarant_skaitymui:	;Per tolimi jumpai
		jmp klaida_atidarant_skaitymui
	@klaida_skaitant:
		jmp klaida_skaitant
;***************************
;Darbas su failais
;***************************
	atidaro_in_faila:
		push si						;Išsaugojamos reikšmės, 
		push cx						;Vėliau grįžtama prie pavadinimų saugojimo
		
		mov ax, 3d00h
		lea dx, in_failas			;Atidaromas pradinis failas
		int 21h
		jc @klaida_atidarant_skaitymui
		mov in_fh, ax	
		
	pasiruosia_skaitymui:
		xor cx,cx
		mov cl, gabalai_n			
		mov di, cx					;Kiek kartų reiks užpildyti bufferį
		
	skaito_gabalus:
		mov cx, gabalai				;Kiek simbolių nuskaitoma
		cmp di, 1					;Kiek gabalų dar reik nuskaityti
		je nuskaito_paskutini
		jb uzdaro_faila				;Jei nebereik, uždaromas output failas
		jmp toliau
		nuskaito_paskutini:			;Jei paskutinis gabalas, atitinkamas dydis
				xor cx,cx
				mov cl, pask_gabalas
		toliau:
		dec di
		mov bx, in_fh
		lea dx, buff				;Nuskaitomas gabalas į bufferį
		mov ax, 3F00h				
		int 21h
		jc @klaida_skaitant
		cmp ax, 0
		je uzdaro_in_faila			;Jei nieko nenuskaityta, uždaro in ir out failus
		push ax
		push cx
		
	sukuria_faila:
		cmp out_fh, 0000			;Patikrina, ar nėra atidarytas joks output failas
		jne raso_gabalus			;Jei atidarytas, nekuria nauja
		call formuoja_pavadinima
		lea dx, out_failas			;Sukuriamas failas		
		mov ax, 3c00h
		int 21h
		jc klaida_atidarant_rasymui
		mov out_fh, ax
		
	raso_gabalus:
		pop cx						
		pop ax						
		mov si,cx					;Išsaugoma, kiek turėjo nuskaityti
		mov cx,ax					;Išsaugoma, kiek iš tikro nuskaitė
		lea dx, buff
		mov bx, out_fh				;Rašymas
		mov ax, 4000h
		int 21h
		jc klaida_rasant
		cmp si, ax					;Jei įrašyta mažiau, reiškias priėjome failo pabaigą
		ja uzdaro_faila_visiskai
		jmp skaito_gabalus

	uzdaro_faila:					;Uždaromas tik output failas
		mov bx, out_fh
		mov ax, 3e00h
		int 21h
		mov out_fh, 0000			;Nunulinama, kad prieš kuriant naują, tikrint ar atidarytas kitas
		jc klaida_uzdarant_rasymui
		jmp pasiruosia_skaitymui	;Grįžtama tęsti input failo skaldymą
		
	uzdaro_faila_visiskai:			;Nebebus kuriamos naujos skaidulos
		mov bx, out_fh				
		mov ax, 3e00h				;Uždaromas rašymo failas
		int 21h
		mov out_fh, 0000
		jc klaida_uzdarant_rasymui
	uzdaro_in_faila:
		mov bx, in_fh
		mov ax, 3e00h				;Uždaromas skaitymo failas
		int 21h
		jc klaida_uzdarant_skaitymui
		
		pop cx						;Grąžinamos reikšmės
		pop si
		cmp cx, 0
		je pabaiga
		jmp pasiruosia_nuskaitymui2	;Einama skaityti kitų failų pavadinimų
;***************************
;Klaidų pranešimai
;***************************
	klaida_atidarant_skaitymui:
		mov dx, offset klaida1
		jmp klaidos_galas
	klaida_atidarant_rasymui:
		mov dx, offset klaida2
		jmp klaidos_galas	
	klaida_skaitant:
		mov dx, offset klaida3
		jmp klaidos_galas
	klaida_rasant:
		mov dx, offset klaida4
		jmp klaidos_galas	
	klaida_uzdarant_skaitymui:
		mov dx, offset klaida5
		jmp klaidos_galas	
	klaida_uzdarant_rasymui:
		mov dx, offset klaida6
		jmp klaidos_galas
	klaidos_galas:
		mov ah, 9
		int 21h
		pop cx
		pop si
		cmp cx, 0
		je pabaiga
		jmp skaito_failo_pav
;*****************************
	pabaiga:
		mov ah, 4Ch
		mov al, 0					
		int 21h
		
end pradzia							